#! /bin/awk -f
#
# extract the upf from oncvpsp output
# 
# expected usage
# awk -f extract_upf.awk [author] [description] pseudopotential.out
# if description is present, it is added to the default description
# of the ONCV pseudopotentials
#
# initialize read variable
BEGIN {
  read = 0
}
# description file present?
FNR == 1 {
  description=index(FILENAME,"description")
  read_author=index(FILENAME,"author")
  if ( read_author > 0 ) author = $0
}
# read description
description != 0 {
  line[read] = $0
  read++
}
# print description
/<PP_INPUTFILE>/ && read > 0 {
  print ""
  for ( i = 0; i < read; i++ ) {
    print " "line[i]
  }
  print "\n"
}
# stop printing when 'End PSP_FPMD' tag is read
/End PSP_UPF/ {
  upf = 0
}
/author/ && author != 0 {
  sub("anonymous",author)
}
# print if we are between two tags
upf == 1 {
  print
}
# start printing when 'Begin PSP_FPMD' tag is read
/Begin PSP_UPF/ {
  upf = 1
}

